from configobj import ConfigObj
import os

confstr="""[app]
fetchthreadcount = 4
downloadthreadcount = 8
player = /usr/bin/mplayer -playlist
savedir = /home/shrek/Music/#must end with '/'
savetempdir = /home/shrek/Music/temp/#must end with '/'
overwrite = True#if local file exists, overwrite it?
minfilesize = 2.0#if file size less than this, don't get the song info. (M)
maxfilesize = 10.0#if file size larger than this, don't get the song info. (M)
filetypes = mp3,#file type to get,if file type is not in this list, don't get the song info"""

fetchthreadcount=4
downloadthreadcount=4
player=''#player exe path
savedir=''#must end with '/'
savetempdir=''#must end with '/'
overwrite=False #if local file exists, overwrite it?
minfilesize=3 #if file size less than this, don't get the song info. (M)
maxfilesize=10 #if file size larger than this, don't get the song info. (M)
filetypes=['mp3','wma'] #file type to get,if file type is not in this list, don't get the song info

try:
    os.mkdir(os.path.join(os.path.expanduser('~'),'.musicextractor'))
except:
    pass
conffile=os.path.join(os.path.join(os.path.expanduser('~'),'.musicextractor'),'app.ini')
if not os.path.exists(conffile):
    open(conffile,'w').write(confstr)
parpath=conffile
if os.path.isfile(parpath):
    parpath=os.path.dirname(os.path.abspath(parpath))
configfile=os.path.join(parpath,'app.ini')
def validate():
    global fetchthreadcount,downloadthreadcount,savedir,savetempdir,overwrite,minfilesize,maxfilesize,filetypes
    if not os.path.exists(savetempdir) or not os.path.exists(savedir):
	return False
    else: return True
def readconfig():
    global configfile,fetchthreadcount,downloadthreadcount,savedir,savetempdir,overwrite,minfilesize,maxfilesize,filetypes,player
    config=ConfigObj(configfile)
    #config.encoding='utf-8'
    #config.default_encoding='utf-8'
    fetchthreadcount=int(config['app']['fetchthreadcount'])
    downloadthreadcount=int(config['app']['downloadthreadcount'])
    player=config['app']['player']
    savedir=config['app']['savedir']
    savetempdir=config['app']['savetempdir']
    overwrite=bool(config['app']['overwrite'])
    minfilesize=float(config['app']['minfilesize'])
    maxfilesize=float(config['app']['maxfilesize'])
    filetypes=config['app']['filetypes']

def writeconfig():
    global configfile,fetchthreadcount,downloadthreadcount,savedir,savetempdir,overwrite,minfilesize,maxfilesize,filetypes,player
    config=ConfigObj(configfile)
    #config.encoding='utf-8'
    #config.default_encoding='utf-8'
    config['app']['fetchthreadcount']=fetchthreadcount
    config['app']['downloadthreadcount']=downloadthreadcount
    config['app']['player']=player
    config['app']['savedir']=savedir
    config['app']['savetempdir']=savetempdir
    config['app']['overwrite']=overwrite
    config['app']['minfilesize']=minfilesize
    config['app']['maxfilesize']=maxfilesize
    config['app']['filetypes']=filetypes
    config.write()
readconfig()
if __name__=='__main__':
    import pdb;pdb.set_trace()
    print 'ok'