from PyQt4.QtGui import *
from PyQt4.QtCore import *
class MixIn(object):
    def createAction(self, text, checkable=False, slot=None, tip=None, shortcut=None, icon=None, signal="triggered()"):
	action=QAction(text, self)
	if slot is not None:
	    self.connect(action, SIGNAL(signal), slot)
	if tip is not None:
	    action.setStatusTip(tip)
	    action.setToolTip(tip)
	if shortcut is not None:
	    action.setShortcut(shortcut)
	if icon is not None:
	    action.setIcon(QIcon(icon))
	if checkable:
	    action.setCheckable(True)
	return action
    def addActions(self, target, actions):
	for action in actions:
	    if action is None:
		target.addSeparator()
	    else:
		target.addAction(action)
    def quitapp(self):
	QCoreApplication.quit()