import urlgrabber
from urlgrabber import progress
from urlparse import urlparse
from urllib import unquote
from lxml import etree
from urllib2 import urlopen
import re
import os
import logging

import socket
# set timeout while fetching pages. 8 seconds.
socket.setdefaulttimeout(8)


logger = logging.getLogger('myapp')
try:
    os.mkdir(os.path.join(os.path.expanduser('~'),'.musicextractor'))
except:
    pass
parpath=os.path.join(os.path.expanduser('~'),'.musicextractor')
if os.path.isfile(parpath):
    parpath=os.path.dirname(os.path.abspath(parpath))
hdlr = logging.FileHandler(os.path.join(parpath,'myapp.log'))
formatter = logging.Formatter('%(asctime)s %(levelname)s %(filename)s[line:%(lineno)d] %(message)s')
hdlr.setFormatter(formatter)
logger.addHandler(hdlr)
logger.setLevel(logging.INFO)


def download(url,filename=None,prog = urlgrabber.progress.text_progress_meter()):    
    #import pdb;pdb.set_trace()    
   
    if filename is not None:
	'''
	filename=url.split('/')[-1]
	filename=unquote(filename)
	'''
	#try:
	    #filename=filename.decode('gb2312').encode('utf-8')
	resp=urlgrabber.urlgrab(url,filename=filename,progress_obj=prog,reget=None)
    else:
	resp=urlgrabber.urlgrab(url,progress_obj=prog,reget=None)
    
def readurl(url,encoding=None):
    try:
	con=urlopen(url)
	resp=con.read()
	con.close()
        if encoding is not None:
            return etree.HTML(resp.decode('gb18030'))
        else:
            return etree.HTML(resp)	
    except UnicodeDecodeError,e:
	logger.exception('error decode html page %s',url)
        return etree.HTML(resp)
    except UnicodeEncodeError,e:
	logger.exception('error encode html page %s',url)
        return etree.HTML(resp)
    except:
	logger.exception('error while reading url %s',url)
        return etree.HTML('<html></html>')

def printtag(tag):
        print etree.tostring(tag,pretty_print=True)
def cleanuptag(tag,pretty_print=True,encoding='utf-8'):
    for child in tag.iterdescendants():
        if child.tag=='script':
            parent=child.getparent()
            index=parent.index(child)
            del parent[index]
            tag=parent.getroottree()
    cnt=etree.tostring(tag,pretty_print=pretty_print,encoding=encoding)
    content = re.sub('&#13;', '', cnt)
    content = re.sub('&nbsp;', ' ', content)
    content = re.sub('<br>', '\n', content)
    content = re.sub('<([^!>]([^>]|\n)*)>', '', content)
    return content.strip()
    
def disUrl(F,I,J):
    try:
	O=""
	E=""
	K={}
	H={}
	def N(S,P,Q): 
	    R=S
	    while R<=P:
		K[R]=R+Q
		H[R+Q]=R
		R+=1	    
	N(0,9,48)
	N(10,35,55)
	N(36,61,61)
	M=F%26
	if not M:M=1
	def A(Q):
	    P=len(Q)
	    S=""
	    for R in Q:
		T=R
		matches=re.findall('[A-Za-z0-9]',T)
		if len(matches)>0:
		    U=H[ord(T)]-M
		    if(U<0):
			U+=62
		    T=chr(K[U])
		S+=T
	    return S
	O=A(I)
	if I==J:E=O
	else:E=A(J)
	return E
    except Exception,e:
	logger.exception("error while handling disUrl F:%s, I:%s, J:%s",F,I,J)	

if __name__=='__main__':
    import sys
    #print disUrl(int(sys.argv[1]),sys.argv[2],sys.argv[3])
    if len(sys.argv)==3:
	download(sys.argv[1],sys.argv[2])
    elif len(sys.argv)==2:
	download(sys.argv[1])
