#! /usr/bin/python
# -*- encoding:utf-8 -*-
from datetime import datetime
import sqlite3

#from sqlalchemy import *
#from sqlalchemy.orm import *
import os
#dbfile=os.path.join(os.path.dirname(__file__),'music.db')
#engine=create_engine('sqlite:///%s'%dbfile)
#metadata=MetaData(engine)

#music_table=Table('music',metadata,
#        Column('id',Integer,primary_key=True),
	#Column('rank',Integer),
        #Column('title',String(250),nullable=False),
        #Column('singer',String(500),nullable=False),
#	Column('album',String(500),nullable=True),
	#Column('stype',String(500),nullable=True),#song type. mp3.wma etc.
	#Column('size',String(500),nullable=True),
 #       Column('url',String(250),nullable=True),
  #      Column('addeddate',DateTime,default=datetime.now()),
   #     Column('tag_list',String(100),default='',nullable=True),
    #    )
#metadata.create_all()

PROP_INDEX_RANK=0
PROP_INDEX_TITLE=1
PROP_INDEX_SINGER=2
PROP_INDEX_ALBUM=3
PROP_INDEX_STYPE=4
PROP_INDEX_SIZE=5
PROP_INDEX_STATE=6
PROP_INDEX_URL=7
PROP_INDEX_ADDEDDATE=8
PROP_INDEX_TAG_LIST=9
PROP_INDEX_ID=10
#conn=sqlite3.connect('/home/shrek/jokes.db',detect_types=sqlite3.PARSE_DECLTYPES|sqlite3.PARSE_COLNAMES)
#cur=conn.cursor()
#cur.execute('create table joke (title text,content text,url text,addeddate date, lastviewdate date,viewtimes int)')
  
class Music(object):
    def __init__(self,rank,title,singer,url,album=u'未知',stype=u'未知',size=u'未知',addeddate=datetime.now(),tags=None):
	self.rank=rank
        self.title=title
	self.singer=singer
	self.album=album
	self.stype=stype
	self.size=size
	self.url=url
	self.addeddate=addeddate	
        self.tag_list=tags
	
	#attached models
	self.fetchmodels=[]
	self.downloadmodels=[]
	self.playmodels=[]
    def __len__(self):
        return 10
    def __getitem__(self, key):
	if key==PROP_INDEX_RANK:
            return self.rank
        if key==PROP_INDEX_TITLE:
            return self.title
        elif key==PROP_INDEX_SINGER:            
            return self.singer
	elif key==PROP_INDEX_ALBUM:            
            return self.album
	elif key==PROP_INDEX_STYPE:            
            return self.stype
	elif key==PROP_INDEX_SIZE:            
            return self.size
	elif key==PROP_INDEX_STATE:            
            return self.__getattribute__('state')
        elif key==PROP_INDEX_URL:
            return self.url
        elif key==PROP_INDEX_ADDEDDATE:
            return self.addeddate
        elif key==PROP_INDEX_TAG_LIST:
            return self.tag_list
        elif key==PROP_INDEX_ID:
            return self.id
    def __setitem__(self, key,value):
	if key==PROP_INDEX_RANK:
            self.rank=value
        elif key==PROP_INDEX_TITLE:
            self.title=value
        elif key==PROP_INDEX_SINGER:            
            self.singer=value
	elif key==PROP_INDEX_ALBUM:            
            self.album=value
	elif key==PROP_INDEX_STYPE:            
            self.stype=value
	elif key==PROP_INDEX_SIZE:            
            self.size=value
	elif key==PROP_INDEX_STATE:            
            self.state=value
        elif key==PROP_INDEX_URL:
            self.url=value
        elif key==PROP_INDEX_ADDEDDATE:
            self.addeddate=value
        elif key==PROP_INDEX_TAG_LIST:
            self.tag_list=value
        elif key==PROP_INDEX_ID:
            self.id=value
    def __unicode__(self):
        return unicode(self.title)
    
    def __getattribute__(self,name):
	try:
	    return object.__getattribute__(self, name)
	except:
	    if name=='state':
		return u'未下载'
	    if name=="isDownloading" or name=="isDownloaded":
		return False
	    raise
    def __setattr__(self,name,value):
	return object.__setattr__(self, name,value)
    def __cmp__(self,other):
	#return QString.localeAwareCompare(self,other)
	try:
	    if int(self.rank.split('.')[0])<int(other.rank.split('.')[0]):
		return -1
	    elif int(self.rank.split('.')[0])==int(other.rank.split('.')[0]):
		return 0
	    elif int(self.rank.split('.')[0])>int(other.rank.split('.')[0]):
		return 1
	except:
	    return -1
class MusicContainer(object):
    def __init__(self):
	#self.musics=getmusic()
	self.musics=[]
	#for music in self.musics:
	#    music.container=self
    def __getitem__(self, key):
        return self.musics[key]
    def append(self,music):
	self.musics.append(music)
    def insert(self,pos,music):
	self.musics.insert(pos,music)
	music.container=self
    def __iter__(self):
        for music in self.musics:
            yield music
    def __len__(self):
        return len(self.musics)
#mapper(Music,music_table)
#def savemusic(music):
#    sess=create_session()
#    sess.save(music)
#    sess.flush()
#def getmusic():
#    sess=create_session()
#    return sess.query(Music).all()
